2018-07-12 14:56:34 +00:00
|
|
|
From 0000000000000000000000000000000000000000 Mon Sep 17 00:00:00 2001
|
2018-04-03 17:41:24 +00:00
|
|
|
From: Peter Jones <pjones@redhat.com>
|
|
|
|
Date: Thu, 15 Mar 2018 14:12:40 -0400
|
2018-07-10 18:39:10 +00:00
|
|
|
Subject: [PATCH] Add grub2-switch-to-blscfg
|
2018-04-03 17:41:24 +00:00
|
|
|
|
|
|
|
Signed-off-by: Peter Jones <pjones@redhat.com>
|
2019-07-16 09:23:51 +00:00
|
|
|
Signed-off-by: Javier Martinez Canillas <javierm@redhat.com>
|
|
|
|
[jhlavac: Use ${etcdefaultgrub} instead of /etc/default/grub]
|
|
|
|
Signed-off-by: Jan Hlavac <jhlavac@redhat.com>
|
2022-03-31 21:21:43 +00:00
|
|
|
[rharwood: skip on ostree installations, migrate man to h2m]
|
2022-03-10 19:46:17 +00:00
|
|
|
Signed-off-by: Robbie Harwood <rharwood@redhat.com>
|
2018-04-03 17:41:24 +00:00
|
|
|
---
|
2022-03-31 21:21:43 +00:00
|
|
|
Makefile.util.def | 7 +
|
|
|
|
docs/man/grub-switch-to-blscfg.h2m | 2 +
|
|
|
|
util/grub-set-password.in | 2 +-
|
|
|
|
util/grub-switch-to-blscfg.in | 317 +++++++++++++++++++++++++++++++++++++
|
|
|
|
util/grub.d/10_linux.in | 2 +-
|
|
|
|
5 files changed, 328 insertions(+), 2 deletions(-)
|
|
|
|
create mode 100644 docs/man/grub-switch-to-blscfg.h2m
|
2018-04-03 17:41:24 +00:00
|
|
|
create mode 100644 util/grub-switch-to-blscfg.in
|
|
|
|
|
|
|
|
diff --git a/Makefile.util.def b/Makefile.util.def
|
2022-03-31 21:21:43 +00:00
|
|
|
index 43a1c7453..a90879fa9 100644
|
2018-04-03 17:41:24 +00:00
|
|
|
--- a/Makefile.util.def
|
|
|
|
+++ b/Makefile.util.def
|
2022-03-22 22:46:46 +00:00
|
|
|
@@ -1365,6 +1365,13 @@ program = {
|
2018-04-03 17:41:24 +00:00
|
|
|
ldadd = '$(LIBINTL) $(LIBDEVMAPPER) $(LIBZFS) $(LIBNVPAIR) $(LIBGEOM)';
|
|
|
|
};
|
|
|
|
|
|
|
|
+script = {
|
|
|
|
+ name = grub-switch-to-blscfg;
|
|
|
|
+ common = util/grub-switch-to-blscfg.in;
|
|
|
|
+ mansection = 8;
|
|
|
|
+ installdir = sbin;
|
|
|
|
+};
|
|
|
|
+
|
|
|
|
program = {
|
|
|
|
name = grub-glue-efi;
|
|
|
|
mansection = 1;
|
2022-03-31 21:21:43 +00:00
|
|
|
diff --git a/docs/man/grub-switch-to-blscfg.h2m b/docs/man/grub-switch-to-blscfg.h2m
|
|
|
|
new file mode 100644
|
|
|
|
index 000000000..fa341426a
|
|
|
|
--- /dev/null
|
|
|
|
+++ b/docs/man/grub-switch-to-blscfg.h2m
|
|
|
|
@@ -0,0 +1,2 @@
|
|
|
|
+[NAME]
|
|
|
|
+grub-switch-to-blscfg \- switch to using BLS config files
|
2019-07-16 09:23:51 +00:00
|
|
|
diff --git a/util/grub-set-password.in b/util/grub-set-password.in
|
2022-03-31 21:21:43 +00:00
|
|
|
index 5ebf50576..c0b5ebbfd 100644
|
2019-07-16 09:23:51 +00:00
|
|
|
--- a/util/grub-set-password.in
|
|
|
|
+++ b/util/grub-set-password.in
|
|
|
|
@@ -1,6 +1,6 @@
|
|
|
|
#!/bin/sh -e
|
|
|
|
|
|
|
|
-EFIDIR=$(grep ^ID= /etc/os-release | sed -e 's/^ID=//' -e 's/rhel/redhat/')
|
|
|
|
+EFIDIR=$(grep ^ID= /etc/os-release | sed -e 's/^ID=//' -e 's/rhel/redhat/' -e 's/\"//g')
|
|
|
|
if [ -d /sys/firmware/efi/efivars/ ]; then
|
|
|
|
grubdir=`echo "/@bootdirname@/efi/EFI/${EFIDIR}/" | sed 's,//*,/,g'`
|
|
|
|
else
|
2018-04-03 17:41:24 +00:00
|
|
|
diff --git a/util/grub-switch-to-blscfg.in b/util/grub-switch-to-blscfg.in
|
|
|
|
new file mode 100644
|
2022-03-31 21:21:43 +00:00
|
|
|
index 000000000..a851424be
|
2018-04-03 17:41:24 +00:00
|
|
|
--- /dev/null
|
|
|
|
+++ b/util/grub-switch-to-blscfg.in
|
2021-03-12 21:54:28 +00:00
|
|
|
@@ -0,0 +1,317 @@
|
2018-04-03 17:41:24 +00:00
|
|
|
+#! /bin/sh
|
|
|
|
+#
|
|
|
|
+# Set a default boot entry for GRUB.
|
|
|
|
+# Copyright (C) 2004,2009 Free Software Foundation, Inc.
|
|
|
|
+#
|
|
|
|
+# GRUB is free software: you can redistribute it and/or modify
|
|
|
|
+# it under the terms of the GNU General Public License as published by
|
|
|
|
+# the Free Software Foundation, either version 3 of the License, or
|
|
|
|
+# (at your option) any later version.
|
|
|
|
+#
|
|
|
|
+# GRUB is distributed in the hope that it will be useful,
|
|
|
|
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
|
|
|
|
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
|
|
|
|
+# GNU General Public License for more details.
|
|
|
|
+#
|
|
|
|
+# You should have received a copy of the GNU General Public License
|
|
|
|
+# along with GRUB. If not, see <http://www.gnu.org/licenses/>.
|
|
|
|
+
|
|
|
|
+#set -eu
|
|
|
|
+
|
|
|
|
+# Initialize some variables.
|
|
|
|
+prefix=@prefix@
|
|
|
|
+exec_prefix=@exec_prefix@
|
2019-07-16 09:23:51 +00:00
|
|
|
+sbindir=@sbindir@
|
2018-04-03 17:41:24 +00:00
|
|
|
+bindir=@bindir@
|
|
|
|
+sysconfdir="@sysconfdir@"
|
|
|
|
+PACKAGE_NAME=@PACKAGE_NAME@
|
|
|
|
+PACKAGE_VERSION=@PACKAGE_VERSION@
|
|
|
|
+datarootdir="@datarootdir@"
|
|
|
|
+datadir="@datadir@"
|
|
|
|
+if [ ! -v pkgdatadir ]; then
|
|
|
|
+ pkgdatadir="${datadir}/@PACKAGE@"
|
|
|
|
+fi
|
|
|
|
+
|
|
|
|
+self=`basename $0`
|
|
|
|
+
|
2019-07-16 09:23:51 +00:00
|
|
|
+grub_get_kernel_settings="${sbindir}/@grub_get_kernel_settings@"
|
2018-04-03 17:41:24 +00:00
|
|
|
+grub_editenv=${bindir}/@grub_editenv@
|
|
|
|
+etcdefaultgrub=/etc/default/grub
|
|
|
|
+
|
2019-07-16 09:23:51 +00:00
|
|
|
+eval "$("${grub_get_kernel_settings}")" || true
|
|
|
|
+
|
|
|
|
+EFIDIR=$(grep ^ID= /etc/os-release | sed -e 's/^ID=//' -e 's/rhel/redhat/' -e 's/\"//g')
|
2018-04-03 17:41:24 +00:00
|
|
|
+if [ -d /sys/firmware/efi/efivars/ ]; then
|
|
|
|
+ startlink=/etc/grub2-efi.cfg
|
|
|
|
+ grubdir=`echo "/@bootdirname@/efi/EFI/${EFIDIR}/" | sed 's,//*,/,g'`
|
|
|
|
+else
|
|
|
|
+ startlink=/etc/grub2.cfg
|
|
|
|
+ grubdir=`echo "/@bootdirname@/@grubdirname@" | sed 's,//*,/,g'`
|
|
|
|
+fi
|
|
|
|
+
|
2019-07-16 09:23:51 +00:00
|
|
|
+blsdir=`echo "/@bootdirname@/loader/entries" | sed 's,//*,/,g'`
|
|
|
|
+
|
2018-04-03 17:41:24 +00:00
|
|
|
+backupsuffix=.bak
|
|
|
|
+
|
2019-07-16 09:23:51 +00:00
|
|
|
+arch="$(uname -m)"
|
|
|
|
+
|
2018-04-03 17:41:24 +00:00
|
|
|
+export TEXTDOMAIN=@PACKAGE@
|
|
|
|
+export TEXTDOMAINDIR="@localedir@"
|
|
|
|
+
|
|
|
|
+. "${pkgdatadir}/grub-mkconfig_lib"
|
|
|
|
+
|
|
|
|
+# Usage: usage
|
|
|
|
+# Print the usage.
|
|
|
|
+usage () {
|
|
|
|
+ gettext_printf "Usage: %s\n" "$self"
|
|
|
|
+ gettext "Switch to BLS config files.\n"; echo
|
|
|
|
+ echo
|
|
|
|
+ print_option_help "-h, --help" "$(gettext "print this message and exit")"
|
|
|
|
+ print_option_help "-V, --version" "$(gettext "print the version information and exit")"
|
|
|
|
+ echo
|
|
|
|
+ print_option_help "--backup-suffix=$(gettext "SUFFIX")" "$backupsuffix"
|
|
|
|
+ print_option_help "--bls-directory=$(gettext "DIR")" "$blsdir"
|
|
|
|
+ print_option_help "--config-file=$(gettext "FILE")" "$startlink"
|
|
|
|
+ print_option_help "--grub-defaults=$(gettext "FILE")" "$etcdefaultgrub"
|
|
|
|
+ print_option_help "--grub-directory=$(gettext "DIR")" "$grubdir"
|
|
|
|
+ # echo
|
|
|
|
+ # gettext "Report bugs to <bug-grub@gnu.org>."; echo
|
|
|
|
+}
|
|
|
|
+
|
|
|
|
+argument () {
|
|
|
|
+ opt=$1
|
|
|
|
+ shift
|
|
|
|
+
|
|
|
|
+ if test $# -eq 0; then
|
|
|
|
+ gettext_printf "%s: option requires an argument -- \`%s'\n" "$self" "$opt" 1>&2
|
|
|
|
+ exit 1
|
|
|
|
+ fi
|
|
|
|
+ echo $1
|
|
|
|
+}
|
|
|
|
+
|
|
|
|
+# Check the arguments.
|
|
|
|
+while test $# -gt 0
|
|
|
|
+do
|
|
|
|
+ option=$1
|
|
|
|
+ shift
|
|
|
|
+
|
|
|
|
+ case "$option" in
|
|
|
|
+ -h | --help)
|
|
|
|
+ usage
|
|
|
|
+ exit 0 ;;
|
|
|
|
+ -V | --version)
|
|
|
|
+ echo "$self (${PACKAGE_NAME}) ${PACKAGE_VERSION}"
|
|
|
|
+ exit 0 ;;
|
|
|
|
+
|
|
|
|
+ --backup-suffix)
|
|
|
|
+ backupsuffix=`argument $option "$@"`
|
|
|
|
+ shift
|
|
|
|
+ ;;
|
|
|
|
+ --backup-suffix=*)
|
|
|
|
+ backupsuffix=`echo "$option" | sed 's/--backup-suffix=//'`
|
|
|
|
+ ;;
|
|
|
|
+
|
|
|
|
+ --bls-directory)
|
|
|
|
+ blsdir=`argument $option "$@"`
|
|
|
|
+ shift
|
|
|
|
+ ;;
|
|
|
|
+ --bls-directory=*)
|
|
|
|
+ blsdir=`echo "$option" | sed 's/--bls-directory=//'`
|
|
|
|
+ ;;
|
|
|
|
+
|
|
|
|
+ --config-file)
|
|
|
|
+ startlink=`argument $option "$@"`
|
|
|
|
+ shift
|
|
|
|
+ ;;
|
|
|
|
+ --config-file=*)
|
|
|
|
+ startlink=`echo "$option" | sed 's/--config-file=//'`
|
|
|
|
+ ;;
|
|
|
|
+
|
|
|
|
+ --grub-defaults)
|
|
|
|
+ etcdefaultgrub=`argument $option "$@"`
|
|
|
|
+ shift
|
|
|
|
+ ;;
|
|
|
|
+ --grub-defaults=*)
|
|
|
|
+ etcdefaultgrub=`echo "$option" | sed 's/--grub-defaults=//'`
|
|
|
|
+ ;;
|
|
|
|
+
|
|
|
|
+ --grub-directory)
|
|
|
|
+ grubdir=`argument $option "$@"`
|
|
|
|
+ shift
|
|
|
|
+ ;;
|
|
|
|
+ --grub-directory=*)
|
|
|
|
+ grubdir=`echo "$option" | sed 's/--grub-directory=//'`
|
|
|
|
+ ;;
|
|
|
|
+
|
|
|
|
+ *)
|
|
|
|
+ gettext_printf "Unrecognized option \`%s'\n" "$option" 1>&2
|
|
|
|
+ usage
|
|
|
|
+ exit 1
|
|
|
|
+ ;;
|
|
|
|
+ esac
|
|
|
|
+done
|
|
|
|
+
|
|
|
|
+find_grub_cfg() {
|
|
|
|
+ local candidate=""
|
2019-07-16 09:23:51 +00:00
|
|
|
+ while [ -e "${candidate}" -o $# -gt 0 ]
|
2018-04-03 17:41:24 +00:00
|
|
|
+ do
|
2019-07-16 09:23:51 +00:00
|
|
|
+ if [ ! -e "${candidate}" ] ; then
|
2018-04-03 17:41:24 +00:00
|
|
|
+ candidate="$1"
|
|
|
|
+ shift
|
|
|
|
+ fi
|
|
|
|
+
|
2019-07-16 09:23:51 +00:00
|
|
|
+ if [ -L "${candidate}" ]; then
|
2018-04-03 17:41:24 +00:00
|
|
|
+ candidate="$(realpath "${candidate}")"
|
|
|
|
+ fi
|
|
|
|
+
|
2019-07-16 09:23:51 +00:00
|
|
|
+ if [ -f "${candidate}" ]; then
|
2018-04-03 17:41:24 +00:00
|
|
|
+ export GRUB_CONFIG_FILE="${candidate}"
|
|
|
|
+ return 0
|
|
|
|
+ fi
|
|
|
|
+ done
|
|
|
|
+ return 1
|
|
|
|
+}
|
|
|
|
+
|
|
|
|
+if ! find_grub_cfg ${startlink} ${grubdir}/grub.cfg ; then
|
|
|
|
+ gettext_printf "Couldn't find config file\n" 1>&2
|
|
|
|
+ exit 1
|
|
|
|
+fi
|
|
|
|
+
|
2019-07-16 09:23:51 +00:00
|
|
|
+if [ ! -d "${blsdir}" ]; then
|
2018-04-03 17:41:24 +00:00
|
|
|
+ install -m 700 -d "${blsdir}"
|
|
|
|
+fi
|
|
|
|
+
|
2019-07-16 09:23:51 +00:00
|
|
|
+if [ -f /etc/machine-id ]; then
|
2018-04-03 17:41:24 +00:00
|
|
|
+ MACHINE_ID=$(cat /etc/machine-id)
|
|
|
|
+else
|
|
|
|
+ MACHINE_ID=$(dmesg | sha256sum)
|
|
|
|
+fi
|
|
|
|
+
|
|
|
|
+mkbls() {
|
|
|
|
+ local kernelver=$1 && shift
|
|
|
|
+ local datetime=$1 && shift
|
2021-03-12 21:54:28 +00:00
|
|
|
+ local kernelopts=$1 && shift
|
2018-04-03 17:41:24 +00:00
|
|
|
+
|
|
|
|
+ local debugname=""
|
2019-07-16 09:23:51 +00:00
|
|
|
+ local debugid=""
|
2018-04-03 17:41:24 +00:00
|
|
|
+ local flavor=""
|
|
|
|
+
|
2019-07-16 09:23:51 +00:00
|
|
|
+ if [ "$kernelver" == *\+* ] ; then
|
2018-04-03 17:41:24 +00:00
|
|
|
+ local flavor=-"${kernelver##*+}"
|
2019-07-16 09:23:51 +00:00
|
|
|
+ if [ "${flavor}" == "-debug" ]; then
|
2018-04-03 17:41:24 +00:00
|
|
|
+ local debugname=" with debugging"
|
2019-07-16 09:23:51 +00:00
|
|
|
+ local debugid="-debug"
|
2018-04-03 17:41:24 +00:00
|
|
|
+ fi
|
|
|
|
+ fi
|
|
|
|
+ (
|
|
|
|
+ source /etc/os-release
|
|
|
|
+
|
|
|
|
+ cat <<EOF
|
|
|
|
+title ${NAME} (${kernelver}) ${VERSION}${debugname}
|
2019-07-16 09:23:51 +00:00
|
|
|
+version ${kernelver}${debugid}
|
2021-03-12 21:54:28 +00:00
|
|
|
+linux /vmlinuz-${kernelver}
|
|
|
|
+initrd /initramfs-${kernelver}.img
|
|
|
|
+options ${kernelopts}
|
2018-04-03 17:41:24 +00:00
|
|
|
+grub_users \$grub_users
|
|
|
|
+grub_arg --unrestricted
|
|
|
|
+grub_class kernel${flavor}
|
|
|
|
+EOF
|
|
|
|
+ ) | cat
|
|
|
|
+}
|
|
|
|
+
|
2019-07-16 09:23:51 +00:00
|
|
|
+copy_bls() {
|
|
|
|
+ for kernelver in $(cd /lib/modules/ ; ls -1) "" ; do
|
|
|
|
+ bls_target="${blsdir}/${MACHINE_ID}-${kernelver}.conf"
|
|
|
|
+ linux="/vmlinuz-${kernelver}"
|
|
|
|
+ linux_path="/boot${linux}"
|
|
|
|
+ kernel_dir="/lib/modules/${kernelver}"
|
|
|
|
+
|
|
|
|
+ if [ ! -d "${kernel_dir}" ] ; then
|
|
|
|
+ continue
|
|
|
|
+ fi
|
|
|
|
+ if [ ! -f "${linux_path}" ]; then
|
|
|
|
+ continue
|
|
|
|
+ fi
|
|
|
|
+
|
|
|
|
+ linux_relpath="$("${grub_mkrelpath}" "${linux_path}")"
|
|
|
|
+ bootprefix="${linux_relpath%%"${linux}"}"
|
2021-03-12 21:54:28 +00:00
|
|
|
+ cmdline="root=${LINUX_ROOT_DEVICE} ro ${GRUB_CMDLINE_LINUX} ${GRUB_CMDLINE_LINUX_DEFAULT}"
|
2019-07-16 09:23:51 +00:00
|
|
|
+
|
2021-03-12 21:54:28 +00:00
|
|
|
+ mkbls "${kernelver}" \
|
|
|
|
+ "$(date -u +%Y%m%d%H%M%S -d "$(stat -c '%y' "${kernel_dir}")")" \
|
|
|
|
+ "${bootprefix}" "${cmdline}" >"${bls_target}"
|
2019-07-16 09:23:51 +00:00
|
|
|
+
|
|
|
|
+ if [ "x$GRUB_LINUX_MAKE_DEBUG" = "xtrue" ]; then
|
|
|
|
+ bls_debug="$(echo ${bls_target} | sed -e "s/${kernelver}/${kernelver}~debug/")"
|
|
|
|
+ cp -aT "${bls_target}" "${bls_debug}"
|
|
|
|
+ title="$(grep '^title[ \t]' "${bls_debug}" | sed -e 's/^title[ \t]*//')"
|
2021-03-12 21:54:28 +00:00
|
|
|
+ options="$(echo "${cmdline} ${GRUB_CMDLINE_LINUX_DEBUG}" | sed -e 's/\//\\\//g')"
|
2019-07-16 09:23:51 +00:00
|
|
|
+ sed -i -e "s/^title.*/title ${title}${GRUB_LINUX_DEBUG_TITLE_POSTFIX}/" "${bls_debug}"
|
2021-03-12 21:54:28 +00:00
|
|
|
+ sed -i -e "s/^options.*/options ${options}/" "${bls_debug}"
|
2019-07-16 09:23:51 +00:00
|
|
|
+ fi
|
|
|
|
+ done
|
|
|
|
+
|
|
|
|
+ if [ -f "/boot/vmlinuz-0-rescue-${MACHINE_ID}" ]; then
|
|
|
|
+ mkbls "0-rescue-${MACHINE_ID}" "0" "${bootprefix}" >"${blsdir}/${MACHINE_ID}-0-rescue.conf"
|
2018-04-03 17:41:24 +00:00
|
|
|
+ fi
|
2019-07-16 09:23:51 +00:00
|
|
|
+}
|
2018-04-03 17:41:24 +00:00
|
|
|
+
|
2021-03-12 21:54:28 +00:00
|
|
|
+# The grub2 EFI binary is not copied to the ESP as a part of an ostree
|
|
|
|
+# transaction. Make sure a grub2 version with BLS support is installed
|
|
|
|
+# but only do this if the blsdir is not set, to make sure that the BLS
|
|
|
|
+# parsing module will search for the BLS snippets in the default path.
|
|
|
|
+if test -f /run/ostree-booted && test -d /sys/firmware/efi/efivars && \
|
|
|
|
+ ! ${grub_editenv} - list | grep -q blsdir && \
|
|
|
|
+ mountpoint -q /boot; then
|
|
|
|
+ grub_binary="$(find /usr/lib/ostree-boot/efi/EFI/${EFIDIR}/ -name grub*.efi)"
|
|
|
|
+ install -m 700 ${grub_binary} ${grubdir} || exit 1
|
|
|
|
+ # Create a hidden file to indicate that grub2 now has BLS support.
|
|
|
|
+ touch /boot/grub2/.grub2-blscfg-supported
|
|
|
|
+fi
|
|
|
|
+
|
2018-04-03 17:41:24 +00:00
|
|
|
+GENERATE=0
|
|
|
|
+if grep '^GRUB_ENABLE_BLSCFG=.*' "${etcdefaultgrub}" \
|
|
|
|
+ | grep -vq '^GRUB_ENABLE_BLSCFG="*true"*\s*$' ; then
|
|
|
|
+ if ! sed -i"${backupsuffix}" \
|
|
|
|
+ -e 's,^GRUB_ENABLE_BLSCFG=.*,GRUB_ENABLE_BLSCFG=true,' \
|
|
|
|
+ "${etcdefaultgrub}" ; then
|
|
|
|
+ gettext_printf "Updating %s failed\n" "${etcdefaultgrub}"
|
|
|
|
+ exit 1
|
|
|
|
+ fi
|
|
|
|
+ GENERATE=1
|
|
|
|
+elif ! grep -q '^GRUB_ENABLE_BLSCFG=.*' "${etcdefaultgrub}" ; then
|
|
|
|
+ if ! echo 'GRUB_ENABLE_BLSCFG=true' >> "${etcdefaultgrub}" ; then
|
|
|
|
+ gettext_printf "Updating %s failed\n" "${etcdefaultgrub}"
|
|
|
|
+ exit 1
|
|
|
|
+ fi
|
|
|
|
+ GENERATE=1
|
|
|
|
+fi
|
|
|
|
+
|
2019-07-16 09:23:51 +00:00
|
|
|
+if [ "${GENERATE}" -eq 1 ] ; then
|
|
|
|
+ copy_bls
|
|
|
|
+
|
|
|
|
+ if [ $arch = "x86_64" ] && [ ! -d /sys/firmware/efi ]; then
|
|
|
|
+ mod_dir="i386-pc"
|
|
|
|
+ elif [ $arch = "ppc64" -o $arch = "ppc64le" ] && [ ! -d /sys/firmware/opal ]; then
|
|
|
|
+ mod_dir="powerpc-ieee1275"
|
|
|
|
+ fi
|
|
|
|
+
|
|
|
|
+ if [ -n "${mod_dir}" ]; then
|
|
|
|
+ for mod in blscfg increment; do
|
2021-03-12 21:54:28 +00:00
|
|
|
+ install -m 700 ${prefix}/lib/grub/${mod_dir}/${mod}.mod ${grubdir}/$mod_dir/ || exit 1
|
2019-07-16 09:23:51 +00:00
|
|
|
+ done
|
|
|
|
+ fi
|
|
|
|
+
|
2018-04-03 17:41:24 +00:00
|
|
|
+ cp -af "${GRUB_CONFIG_FILE}" "${GRUB_CONFIG_FILE}${backupsuffix}"
|
|
|
|
+ if ! grub2-mkconfig -o "${GRUB_CONFIG_FILE}" ; then
|
2021-03-12 21:54:28 +00:00
|
|
|
+ install -m 700 "${GRUB_CONFIG_FILE}${backupsuffix}" "${GRUB_CONFIG_FILE}"
|
2018-04-03 17:41:24 +00:00
|
|
|
+ sed -i"${backupsuffix}" \
|
|
|
|
+ -e 's,^GRUB_ENABLE_BLSCFG=.*,GRUB_ENABLE_BLSCFG=false,' \
|
2019-07-16 09:23:51 +00:00
|
|
|
+ "${etcdefaultgrub}"
|
2018-04-03 17:41:24 +00:00
|
|
|
+ gettext_printf "Updating %s failed\n" "${GRUB_CONFIG_FILE}"
|
|
|
|
+ exit 1
|
|
|
|
+ fi
|
|
|
|
+fi
|
|
|
|
+
|
|
|
|
+# Bye.
|
|
|
|
+exit 0
|
2022-03-10 19:46:17 +00:00
|
|
|
diff --git a/util/grub.d/10_linux.in b/util/grub.d/10_linux.in
|
2022-04-12 18:42:54 +00:00
|
|
|
index f1548a260..c02c1f082 100644
|
2022-03-10 19:46:17 +00:00
|
|
|
--- a/util/grub.d/10_linux.in
|
|
|
|
+++ b/util/grub.d/10_linux.in
|
|
|
|
@@ -138,7 +138,7 @@ blsdir="/boot/loader/entries"
|
|
|
|
|
|
|
|
get_sorted_bls()
|
|
|
|
{
|
|
|
|
- if ! [ -d "${blsdir}" ]; then
|
2022-03-23 23:48:18 +00:00
|
|
|
+ if ! [ -d "${blsdir}" ] || [ -f /run/ostree-booted ] || [ -d /ostree/repo ]; then
|
2022-03-10 19:46:17 +00:00
|
|
|
return
|
|
|
|
fi
|
|
|
|
|